| polydot

## Wiki

The master copies of EMBOSS documentation are available at http://emboss.open-bio.org/wiki/Appdocs on the EMBOSS Wiki.

Please help by correcting and extending the Wiki pages.

## Function

Draw dotplots for all-against-all comparison of a sequence set

## Description

polydot generates a dotplot for each of an all-against-all comparison of a set of sequences. The dotplots are rendered on a single diagram. The dotplot is an intuitive graphical representation of the regions of similarity between two sequences. All positions from the first input sequence are compared with all positions from the second input sequence searching for exact matches between sequence regions ("words"). The two sequences are the axes of the rectangular dotplot. Wherever there is "similarity" between a word from each sequences a dot is plotted. The wordsize is specified by the user. Optionally, information on the sequence and location of all the exact matching regions may be written to file as a feature file.

## Algorithm

All sequence words of the specified size from the first input sequence are compared with all words from the second input sequence and exact matches identified. A line is plotted on the dotplot corresponding to any exact matching words. Thus any local regions of identity correspond to diagonals in the dotplot.

## Usage

Here is a sample session with polydot

    % polydot globins.fasta -gtitle="Polydot of globins.fasta" -graph cps
    Draw dotplots for all-against-all comparison of a sequence set
    Word size [6]:

    Created polydot.ps

Go to the input files for this example
Go to the output files for this example

## Command line arguments

    Draw dotplots for all-against-all comparison of a sequence set
    Version: EMBOSS:6.6.0.0

       Standard (Mandatory) qualifiers (* if not always prompted):
      [-sequences]         seqset     File containing a sequence alignment
       -wordsize           integer    [6] Word size (Integer 2 or more)
    *  -outfeat            featout    [unknown.gff] Output features UFO
       -graph              graph      [$EMBOSS_GRAPHICS value, or x11] Graph type
                                      (ps, hpgl, hp7470, hp7580, meta, cps, x11,
                                      tek, tekt, none, data, xterm, png, gif, pdf,
                                      svg)

       Additional (Optional) qualifiers:
       -[no]boxit          boolean    [Y] Draw a box around each dotplot
       -dumpfeat           toggle     [N] Dump all matches as feature files

       Advanced (Unprompted) qualifiers:
       -gap                integer    [10] This specifies the size of the gap that
                                      is used to separate the individual dotplots
                                      in the display. The size is measured in
                                      residues, as displayed in the output.
                                      (Integer 0 or more)

       Associated qualifiers:

       "-sequences" associated qualifiers
       -sbegin1            integer    Start of each sequence to be used
       -send1              integer    End of each sequence to be used
       -sreverse1          boolean    Reverse (if DNA)
       -sask1              boolean    Ask for begin/end/reverse
       -snucleotide1       boolean    Sequence is nucleotide
       -sprotein1          boolean    Sequence is protein
       -slower1            boolean    Make lower case
       -supper1            boolean    Make upper case
       -scircular1         boolean    Sequence is circular
       -squick1            boolean    Read id and sequence only
       -sformat1           string     Input sequence format
       -iquery1            string     Input query fields or ID list
       -ioffset1           integer    Input start position offset
       -sdbname1           string     Database name
       -sid1               string     Entryname
       -ufo1               string     UFO features
       -fformat1           string     Features format
       -fopenfile1         string     Features file name

       "-outfeat" associated qualifiers
       -offormat           string     Output feature format
       -ofopenfile         string     Features file name
       -ofextension        string     File name extension
       -ofdirectory        string     Output directory
       -ofname             string     Base file name
       -ofsingle           boolean    Separate file for each entry

       "-graph" associated qualifiers
       -gprompt            boolean    Graph prompting
       -gdesc              string     Graph description
       -gtitle             string     Graph title
       -gsubtitle          string     Graph subtitle
       -gxtitle            string     Graph x axis title
       -gytitle            string     Graph y axis title
       -goutfile           string     Output file for non interactive displays
       -gdirectory         string     Output directory

       General qualifiers:
       -auto               boolean    Turn off prompts
       -stdout             boolean    Write first file to standard output
       -filter             boolean    Read first file from standard input, write
                                      first file to standard output
       -options            boolean    Prompt for standard and additional values
       -debug              boolean    Write debug output to program.dbg
       -verbose            boolean    Report some/full command line options
       -help               boolean    Report command line options and exit. More
                                      information on associated and general
                                      qualifiers can be found with -help -verbose
       -warning            boolean    Report warnings
       -error              boolean    Report errors
       -fatal              boolean    Report fatal errors
       -die                boolean    Report dying program messages
       -version            boolean    Report version number and exit

Qualifier | Type | Description | Allowed values | Default
--- | --- | --- | --- | ---
Standard (Mandatory) qualifiers
[-sequences] (Parameter 1) | seqset | File containing a sequence alignment | Readable set of sequences | Required
-wordsize | integer | Word size | Integer 2 or more | 6
-outfeat | featout | Output features UFO | Writeable feature table | unknown.gff
-graph | graph | Graph type | EMBOSS has a list of known devices, including ps, hpgl, hp7470, hp7580, meta, cps, x11, tek, tekt, none, data, xterm, png, gif, pdf, svg | EMBOSS_GRAPHICS value, or x11
Additional (Optional) qualifiers
-[no]boxit | boolean | Draw a box around each dotplot | Boolean value Yes/No | Yes
-dumpfeat | toggle | Dump all matches as feature files | Toggle value Yes/No | No
Advanced (Unprompted) qualifiers
-gap | integer | This specifies the size of the gap that is used to separate the individual dotplots in the display. The size is measured in residues, as displayed in the output. | Integer 0 or more | 10
Associated qualifiers
"-sequences" associated seqset qualifiers
-sbegin1 -sbegin_sequences | integer | Start of each sequence to be used | Any integer value | 0
-send1 -send_sequences | integer | End of each sequence to be used | Any integer value | 0
-sreverse1 -sreverse_sequences | boolean | Reverse (if DNA) | Boolean value Yes/No | N
-sask1 -sask_sequences | boolean | Ask for begin/end/reverse | Boolean value Yes/No | N
-snucleotide1 -snucleotide_sequences | boolean | Sequence is nucleotide | Boolean value Yes/No | N
-sprotein1 -sprotein_sequences | boolean | Sequence is protein | Boolean value Yes/No | N
-slower1 -slower_sequences | boolean | Make lower case | Boolean value Yes/No | N
-supper1 -supper_sequences | boolean | Make upper case | Boolean value Yes/No | N
-scircular1 -scircular_sequences | boolean | Sequence is circular | Boolean value Yes/No | N
-squick1 -squick_sequences | boolean | Read id and sequence only | Boolean value Yes/No | N
-sformat1 -sformat_sequences | string | Input sequence format | Any string |
-iquery1 -iquery_sequences | string | Input query fields or ID list | Any string |
-ioffset1 -ioffset_sequences | integer | Input start position offset | Any integer value | 0
-sdbname1 -sdbname_sequences | string | Database name | Any string |
-sid1 -sid_sequences | string | Entryname | Any string |
-ufo1 -ufo_sequences | string | UFO features | Any string |
-fformat1 -fformat_sequences | string | Features format | Any string |
-fopenfile1 -fopenfile_sequences | string | Features file name | Any string |
"-outfeat" associated featout qualifiers
-offormat | string | Output feature format | Any string |
-ofopenfile | string | Features file name | Any string |
-ofextension | string | File name extension | Any string |
-ofdirectory | string | Output directory | Any string |
-ofname | string | Base file name | Any string |
-ofsingle | boolean | Separate file for each entry | Boolean value Yes/No | N
"-graph" associated graph qualifiers
-gprompt | boolean | Graph prompting | Boolean value Yes/No | N
-gdesc | string | Graph description | Any string | Poly dotplot
-gtitle | string | Graph title | Any string |
-gsubtitle | string | Graph subtitle | Any string |
-gxtitle | string | Graph x axis title | Any string |
-gytitle | string | Graph y axis title | Any string |
-goutfile | string | Output file for non interactive displays | Any string |
-gdirectory | string | Output directory | Any string |
General qualifiers
-auto | boolean | Turn off prompts | Boolean value Yes/No | N
-stdout | boolean | Write first file to standard output | Boolean value Yes/No | N
-filter | boolean | Read first file from standard input, write first file to standard output | Boolean value Yes/No | N
-options | boolean | Prompt for standard and additional values | Boolean value Yes/No | N
-debug | boolean | Write debug output to program.dbg | Boolean value Yes/No | N
-verbose | boolean | Report some/full command line options | Boolean value Yes/No | Y
-help | boolean | Report command line options and exit. More information on associated and general qualifiers can be found with -help -verbose | Boolean value Yes/No | N
-warning | boolean | Report warnings | Boolean value Yes/No | Y
-error | boolean | Report errors | Boolean value Yes/No | Y
-fatal | boolean | Report fatal errors | Boolean value Yes/No | Y
-die | boolean | Report dying program messages | Boolean value Yes/No | Y
-version | boolean | Report version number and exit | Boolean value Yes/No | N

## Input file format

polydot reads in a set of nucleic or protein sequences.

The sequences may or may not be aligned.

### Input files for usage example

### File: globins.fasta

    >HBB_HUMAN Sw:Hbb_Human => HBB_HUMAN
    VHLTPEEKSAVTALWGKVNVDEVGGEALGRLLVVYPWTQRFFESFGDLSTPDAVMGNPKV
    KAHGKKVLGAFSDGLAHLDNLKGTFATLSELHCDKLHVDPENFRLLGNVLVCVLAHHFGK
    EFTPPVQAAYQKVVAGVANALAHKYH
    >HBB_HORSE Sw:Hbb_Horse => HBB_HORSE
    VQLSGEEKAAVLALWDKVNEEEVGGEALGRLLVVYPWTQRFFDSFGDLSNPGAVMGNPKV
    KAHGKKVLHSFGEGVHHLDNLKGTFAALSELHCDKLHVDPENFRLLGNVLVVVLARHFGK
    DFTPELQASYQKVVAGVANALAHKYH
    >HBA_HUMAN Sw:Hba_Human => HBA_HUMAN
    VLSPADKTNVKAAWGKVGAHAGEYGAEALERMFLSFPTTKTYFPHFDLSHGSAQVKGHGK
    KVADALTNAVAHVDDMPNALSALSDLHAHKLRVDPVNFKLLSHCLLVTLAAHLPAEFTPA
    VHASLDKFLASVSTVLTSKYR
    >HBA_HORSE Sw:Hba_Horse => HBA_HORSE
    VLSAADKTNVKAAWSKVGGHAGEYGAEALERMFLGFPTTKTYFPHFDLSHGSAQVKAHGK
    KVGDALTLAVGHLDDLPGALSNLSDLHAHKLRVDPVNFKLLSHCLLSTLAVHLPNDFTPA
    VHASLDKFLSSVSTVLTSKYR
    >MYG_PHYCA Sw:Myg_Phyca => MYG_PHYCA
    VLSEGEWQLVLHVWAKVEADVAGHGQDILIRLFKSHPETLEKFDRFKHLKTEAEMKASED
    LKKHGVTVLTALGAILKKKGHHEAELKPLAQSHATKHKIPIKYLEFISEAIIHVLHSRHP
    GDFGADAQGAMNKALELFRKDIAAKYKELGYQG
    >GLB5_PETMA Sw:Glb5_Petma => GLB5_PETMA
    PIVDTGSVAPLSAAEKTKIRSAWAPVYSTYETSGVDILVKFFTSTPAAQEFFPKFKGLTT
    ADQLKKSADVRWHAERIINAVNDAVASMDDTEKMSMKLRDLSGKHAKSFQVDPQYFKVLA
    AVIADTVAAGDAGFEKLMSMICILLRSAY
    >LGB2_LUPLU Sw:Lgb2_Luplu => LGB2_LUPLU
    GALTESQAALVKSSWEEFNANIPKHTHRFFILVLEIAPAAKDLFSFLKGTSEVPQNNPEL
    QAHAGKVFKLVYEAAIQLQVTGVVVTDATLKNLGSVHVSKGVADAHFPVVKEAILKTIKE
    VVGAKWSEELNSAWTIAYDELAIVIKKEMNDAA

## Output file format

A graphical image is displayed on the specified graphics device.

### Output files for usage example

### Graphics File: polydot.ps

## Data files

None.

## Notes

Where the two sequences have substantial regions of identity, longer diagonal lines appear in the plot. It is possible to see at a glance such local regions of identity. It is also easy to see other features such as repeats (which form parallel diagonal lines), and insertions or deletions (which form breaks or discontinuities in the diagonal lines).

## References

None.

## Warnings

None.

## Diagnostic Error Messages

None.

## Exit status

0 if successful.

## Known bugs

None.

## See also

Program name | Description
--- | ---
dotmatcher | Draw a threshold dotplot of two sequences
dotpath | Draw a non-overlapping wordmatch dotplot of two sequences
dottup | Display a wordmatch dotplot of two sequences

## Author(s)

Ian Longden formerly at:
Sanger Institute, Wellcome Trust Genome Campus, Hinxton, Cambridge, CB10 1SA, UK.

Please report all bugs to the EMBOSS bug team (emboss-bug © emboss.open-bio.org) not to the original author.

## History

Completed 2nd June 1999.

## Target users

This program is intended to be used by everyone and everything, from naive users to embedded scripts.

## Comments

None